;---------------------------------
;FILE:		3byte add.asm
;AUTHOR:		Water.Lee
;COMPANY:		HyCon Tek
;DEVICE:		HY11P13_Z0813AB
;INPUT:		
;OUTPUT:		
;CREATED:		
;UPDATED:		2008/5/16 W 10:21:56
;DESCRIP:		add code
;			
;TPYE:		Confidential
;---------------------------------                     
ORG		000H
		jmp   ProBegin
org   	0004h

ProBegin: 

       mvl      11011100b		; ENABLE LCD, PUMP, VLCD=3.05V, BF ON, 1/3BIAS
       mvf      LCDCN1,F,ACCE		; ENLCD[7]=1, ENABLE LCD
       						; LCDPR[6]=1, ENABLE INTERNAL PUMP VLCD
       						; VLCDx[5:4]=00, VLCD=3.30V
       						;		   01, VLCD=3.05V
       						;		   10, VLCD=2.80V
       						;		   11, VLCD=2.55V
       						; LCDBF[3]=1, BUFFER ON
       						; LCDBI[2:1]=00, BIAS=STATIC
       						; 		   01, BIAS=1/2BIAS
       						; 		   10, BIAS=1/3BIAS
       						; 		   11, X
       mvl      01100000b		
       mvf      LCDCN2,F,ACCE		; LCDBL[7]=0, BLINKING ON, LCD
       						;		 1, BLINKING OFF, LCD


;*********more*********************
		MVL		01010101b
		MVF		ADShM,F,A		;L
		MVL		01010101b		
		MVF		ADShM+1,F,A	;M
		MVL		00001010B
		MVF		ADShM+2,F,A	;H
		
;**********************************
		
		
;		mvff     ADC0RL,ADShM     
;		mvff     ADC0RM,ADShM+1     
;		mvff     ADC0RH,ADShM+2     
							;L		M	  H
							;ADBG+0,ADBG+1,ADBG+2: AD BUFFER 1
							;ADBG+3,ADBG+4,ADBG+5: AD BUFFER 2
							;ADBG+6,ADBG+7,ADBG+8: AD BUFFER 3
							;average result:
							;  ada1, ada1+1, ada1+2							
		BCF		STATUS,C,A	;NADO OV Bit˥h,ɻ
		RLFC     	ADShM,F,A
         	RLFC		ADShM+1,F,A
         	RLFC		ADShM+2,F,A
         	BTSZ		STATUS,C,A
         	BSF		ADShM+2,7,A

		MVL		005H
		MVF		0F0H,F,A		;MwᱼXbitơAADO`@X+/-17BIT DATA
SHIFTADO:						;k6ADO
		RRFC		ADShM+2,F,A
		RRFC		ADShM+1,F,A
		RRFC		ADShM+0,F,A
		MVL		00H
		BTSZ		STATUS,C,A
		MVL		0FFH
		DCF		0F0H,F,A
		RRFC		WREG,W,A
		TFSZ		0F0H,A
		JMP		SHIFTADO
		MVL		007H			;BADOH MSB 6bit
		ANDF		ADShM+2,F,A
		
		MVFF		ADShM+0,ADBG+0
		MVFF		ADShM+1,ADBG+1
		MVFF		ADShM+2,ADBG+2
		MVFF		ADShM+0,ADBG+3
		MVFF		ADShM+1,ADBG+4
		MVFF		ADShM+2,ADBG+5
		MVFF		ADShM+0,ADBG+6
		MVFF		ADShM+1,ADBG+7
		MVFF		ADShM+2,ADBG+8
		

		MVF		ADShM+0,W,A	;3BYTE ADBG+ASShM; BUFFER 1
		ADDF		ADBG+0,F,A
		BTSZ		STATUS,C,A
		INF		ADBG+1,F,A
		MVF		ADShM+1,W,A
		ADDF		ADBG+1,F,A
		BTSZ		STATUS,C,A
		INF		ADBG+2,F,A
		MVF		ADShM+2,W,A
		ADDF		ADBG+2,F,A
		BCF		STATUS,C,A
		RRFC		ADBG+2,F,A	;Ĥ@Өⵧȥʧ@
		RRFC		ADBG+1,F,A
		RRFC		ADBG+0,F,A
		
		MVF		ADBG+0,W,A	;3BYTE ADBG+ASShM; BUFFER 2
		ADDF		ADBG+3,F,A
		BTSZ		STATUS,C,A
		INF		ADBG+4,F,A
		MVF		ADBG+1,W,A
		ADDF		ADBG+4,F,A
		BTSZ		STATUS,C,A
		INF		ADBG+5,F,A
		MVF		ADBG+2,W,A
		ADDF		ADBG+5,F,A
		BCF		STATUS,C,A
		RRFC		ADBG+5,F,A	;ĤGӨⵧȥʧ@
		RRFC		ADBG+4,F,A
		RRFC		ADBG+3,F,A
		
		MVF		ADBG+3,W,A	;3BYTE ADBG+ASShM; BUFFER 3
		ADDF		ADBG+6,F,A
		BTSZ		STATUS,C,A
		INF		ADBG+7,F,A
		MVF		ADBG+4,W,A
		ADDF		ADBG+7,F,A
		BTSZ		STATUS,C,A
		INF		ADBG+8,F,A
		MVF		ADBG+5,W,A
		ADDF		ADBG+8,F,A
		BCF		STATUS,C,A
		RRFC		ADBG+8,F,A	;ĤTӨⵧȥʧ@
		RRFC		ADBG+7,F,A
		RRFC		ADBG+6,F,A
		
		MVFF		ADBG+8,ADA0+2
		MVFF		ADBG+7,ADA0+1
		MVFF		ADBG+6,ADA0+0
		

SHOWADC:       
       MVF     ADA0,W,ACCE		;+/-
       MVF     TEMP,F,ACCE
       MVF     ADA0+1,W,ACCE
       MVF     TEMP+1,F,ACCE
       MVF     ADA0+2,W,ACCE
       MVF     TEMP+2,F,ACCE
       BCF     ADCFG,B_NEG,ACCE
       BTSS    ADA0+2,1,ACCE
       JMP     GETADC_1
       BSF     ADCFG,B_NEG,ACCE
       COMF    TEMP,F,ACCE
       COMF    TEMP+1,F,ACCE
       COMF    TEMP+2,F,ACCE
       MVL     1
       ADDF    TEMP,F,ACCE
       MVL     1
       ADDF    TEMP+1,F,ACCE
       MVL     0
       ADDC    TEMP+2,F,ACCE
    GETADC_1:   
       LDPR    TEMP,FSR1
       LDPR    TEMP+3,FSR0		;+3
       MVL     3				;3
       CALL    HTOB    
       MVL     LCD1
       MVF     DSP+1,F,ACCE
       LDPR    TEMP+3,FSR0		;3
       MVL     5
       MVF     DSP+3,F,ACCE
       MVL     HIGH  LCD1
       ;IORL    0F0H   ; DON'T DROUP OUT ZERO
       IORL    000H
       MVF     DSP+4,F,ACCE
       CALL    DISPLAY     
       BTSS    ADCFG,B_NEG,ACCE
       JMP     GETADC_2
       BSF     RLCDG,B_LNEG,ACCE
       JMP     GETADC_3
    GETADC_2:
       BCF     RLCDG,B_LNEG,ACCE
    GETADC_3:

	
	JMP		ProBegin
	NOP
Include  HY11P13.INC
Include  Main.inc
INCLUDE	DISPLAY_WATER.ASM	       	
INCLUDE	LCDINDX_WATER.ASM
INCLUDE	MATH_WATER.ASM

END		