Display:
; translate internal value to decimal
; belongs to class of display sections
; dsp : index,2 nibbles
; dsp+1 : index, 2 nibbles (*** display position ***)
; dsp+2 : addr, 2 nibbles (bank 1)
; dsp+3 : length , 1 nibble
; dsp+4 : drop zero
; dsp+5 : point position
;=====================================================
;  NDSP+2IndexgJDSP1    
        mvf     dsp+3,W,ACCE
        mvf     r_Len,F,ACCE
        ldpr     dsp1,FSR1
dispa_a:
        mvf     INDF0,W,ACCE
        andl    0Fh
        mvf     POINC1,F,ACCE
        dcsz    r_Len,f,ACCE
        jmp    dispa_b
        jmp    dispa_c
dispa_b:
        mvf     POINC0,W,ACCE
        swpf    wreg,F,ACCE
        andl    0fh
        mvf     POINC1,F,ACCE
        dcsz    r_Len,F,ACCE
        jmp     dispa_a
;=====================================================
;MPointe0
dispa_c:
        mvf     dsp+4,W,ACCE
        andl     0Fh
        mvf     FSR0H,F,ACCE
        dcf     FSR1L,W,ACCE
        mvf     dsp+2,F,ACCE
        inf     dsp+5,f,ACCE
        mvl     1
        cpse    dsp+5,ACCE
        jmp     dispnx5
        mvf     dsp+3,W,ACCE
        addf    dsp+1,W,ACCE
        mvf     FSR0L,F,ACCE
        clrf    INDF0,ACCE
        dcf     dsp+2,F,ACCE        
        dcsz    dsp+3,F,ACCE
        jmp     dispnx5
        jmp     dispnx3
dispnx5:
        mvf     dsp+5,W,acce
        tfsz    dsp+5,ACCE
        jmp     dipslp4
        JMP     dispnx3
      dipslp4:  
        mvf     dsp+3,W,ACCE
        mvf     r_Len,F,ACCE
        xorl    1
        btsz    status,z,ACCE
        jmp     dispnx3
        clrf    s_reg,ACCE
        mvf     dsp+2,W,ACCE
        mvf     fsr0L,F,ACCE
        swpf    dsp+4,W,ACCE
        andl    0Fh
        xorl    0fh             ; dsp+4 = 0Fh no drop zero
        btsz    status,z,ACCE
        jmp     dispnx3
displp3:
        mvf     dsp+5,W,ACCE
        xorf    r_Len,w,ACCE
        btsz    status,z,ACCE
        jmp     dispnx3
        tfsz    INDF0,ACCE 
        jmp     dispnx3           ; end drop zero
        dcf     FSR0L,F,ACCE
        inf     s_reg,f,ACCE
        dcf     r_Len,f,ACCE
        mvl     2                 
        subf    r_Len,w,ACCE           ; when <= 1
        btsz    status,c,ACCE
        jmp     displp3
dispnx3:
                            ; begin  drop zero
        mvf     fsr0L,W,ACCE
        mvf     dsp,F,ACCE
        mvf     dsp+1,W,ACCE
        mvf     fsr0L,F,ACCE
        tfsz    s_reg,ACCE
        jmp     dispnt
        jmp     dispnt1
dispnt:
        clrf    POINC0,ACCE
        dcsz    s_reg,F,ACCE
        jmp     dispnt
dispnt1:
        mvf     dsp,W,ACCE    ; FSR0 =  , FSR1 = ƭ    
        mvf     FSR1L,F,ACCE   
displp1:
        mvf     INDF1,W,ACCE
        bcf     status,c,ACCE
        rrfc    WREG,F,ACCE
        call    LDISP
        mvf     TBLDL,W,ACCE
        btss    PODEC1,0,ACCE
        mvf     TBLDH,W,ACCE
        mvf     s_reg,F,ACCE
        mvf     dsp+5,W,ACCE
        cpse    r_Len,ACCE
        jmp     dispnx1
        mvf     s_reg,W,ACCE
        iorl    80h         ; give point
        jmp     dispnx2
dispnx1:
        mvf     s_reg,W,ACCE
dispnx2:
        mvf     POINC0,F,ACCE
        dcsz    r_Len,f,ACCE
        jmp    displp1
        ret
;==========================================
ClearLCD:						; MLCD0~LCD7
       ldpr     LCD0,FSR1
     LCDCR1:  
       clrf     POINC1,ACCE
       mvl      LCD9
       cpse     FSR1L,ACCE
       jmp      LCDCR1              
       mvl      11011100b		; ENABLE LCD, PUMP, VLCD=3.05V, BF ON, 1/3BIAS
       mvf      LCDCN1,F,ACCE		; ENLCD[7]=1, ENABLE LCD
       						; LCDPR[6]=1, ENABLE INTERNAL PUMP VLCD
       						; VLCDx[5:4]=00, VLCD=3.30V
       						;		   01, VLCD=3.05V
       						;		   10, VLCD=2.80V
       						;		   11, VLCD=2.55V
       						; LCDBF[3]=1, BUFFER ON
       						; LCDBI[2:1]=00, BIAS=STATIC
       						; 		   01, BIAS=1/2BIAS
       						; 		   10, BIAS=1/3BIAS
       						; 		   11, X
       mvl      01100000b		
       mvf      LCDCN2,F,ACCE		; LCDBL[7]=0, BLINKING ON, LCD
       						;		 1, BLINKING OFF, LCD
       ret
;==================================
ShowZero:
       clrf    LCD0,ACCE
       clrf    LCD1,ACCE
       mvl     LCDNUMz
       mvf     LCD2,F,ACCE
       mvl     LCDNUME
       mvf     LCD3,F,ACCE
       mvl     LCDNUMr
       mvf     LCD4,F,ACCE
       mvl     LCDNUMo
       mvf     LCD5,F,ACCE
       ret
;==================================
ShowOK:
       clrf    LCD0,ACCE
       mvl     LCDNUMC
       mvf     LCD1,F,ACCE
       mvl     LCDNUMA
       mvf     LCD2,F,ACCE
       mvl     LCDNUML
       mvf     LCD3,F,ACCE
       mvl     LCDNUMO
       mvf     LCD4,F,ACCE
       mvl     LCDNUMK
       mvf     LCD5,F,ACCE
       ret
;==================================
ShowTare:
       clrf    LCD0,ACCE
       clrf    LCD1,ACCE
       mvl     LCDNUMt
       mvf     LCD2,F,ACCE
       mvl     LCDNUMA
       mvf     LCD3,F,ACCE
       mvl     LCDNUMr
       mvf     LCD4,F,ACCE
       mvl     LCDNUME
       mvf     LCD5,F,ACCE
       ret
;==================================
ShowOL:
      bcf     RLCDG,b_lneg,ACCE
       clrf    LCD1,ACCE
       mvl     LCDDash
       mvf     LCD2,F,ACCE
       mvl     LCDNUMo
       mvf     LCD3,F,ACCE
       mvl     LCDNUML
       mvf     LCD4,F,ACCE
       mvl     LCDDash
       mvf     LCD5,F,ACCE
       ret
;==================================
ShowCFAIL:
       bcf     RLCDG,b_lneg,ACCE
       mvl     LCDNUMC
       mvf     LCD1,F,ACCE
       mvl     LCDNUMF
       mvf     LCD2,F,ACCE
       mvl     LCDNUMA
       mvf     LCD3,F,ACCE
       mvl     LCDNUMi
       mvf     LCD4,F,ACCE
       mvl     LCDNUML
       mvf     LCD5,F,ACCE
       IDLE
       NOP
;==================================
CALOK:
	CLRF		LCD0,A
     MVL		LCDNUMC			;C
	MVF		LCD1,F,A
	MVL		LCDNUMA			;A
	MVF		LCD2,F,A
	MVL		LCDNUML			;L
	MVF		LCD3,F,A
	MVL		LCDNUMO			;O
	MVF		LCD4,F,A
	MVL		LCDNUMK			;K
	MVF		LCD5,F,A
	BTSZ		MCKCN3,PERCK,A
	CALL		DELAY200MS
	CALL		DELAY10MS
RET	


;==================================
SHOW321:
	CLRF		LCD0,A
     MVL		LCDNUM3			
	MVF		LCD1,F,A
	MVF		LCD2,F,A
	MVF		LCD3,F,A
	MVF		LCD4,F,A
	MVF		LCD5,F,A
	CALL		DELAY200MS
     MVL		LCDNUM2
	MVF		LCD1,F,A
	MVF		LCD2,F,A
	MVF		LCD3,F,A
	MVF		LCD4,F,A
	MVF		LCD5,F,A
	CALL		DELAY200MS
     MVL		LCDNUM1
	MVF		LCD1,F,A
	MVF		LCD2,F,A
	MVF		LCD3,F,A
	MVF		LCD4,F,A
	MVF		LCD5,F,A
	CALL		DELAY200MS
     MVL		LCDNUM0
	MVF		LCD1,F,A
	MVF		LCD2,F,A
	MVF		LCD3,F,A
	MVF		LCD4,F,A
	MVF		LCD5,F,A
	CALL		DELAY200MS
	CALL		ClearLCD	
	CALL		DELAY200MS
RET	
                                                             