;---------------------------------
;FILE:		11P13.INC
;AUTHOR:		lhmhome.lin and mark by Water.Lee
;COMPANY:		HyCon Tek
;DEVICE:		HY11P13_Z0813AB
;INPUT:		
;OUTPUT:		
;CREATED:		
;UPDATED:		2008/5/16 U 01:07:17
;DESCRIP:		11P13 REGISTER DEFINITION
;TPYE:		Confidential
;---------------------------------                     
INDF0		EQU		000h
POINC0    	EQU		001h
PODEC0    	EQU		002h
PRINC0  		EQU		003h
PLUSW0   		EQU		004h
INDF1   		EQU		005h
POINC1    	EQU		006h
PODEC1    	EQU		007h
PRINC1 	 	EQU		008h
PLUSW1    	EQU		009h
FSR0H   		EQU		00fh
FSR0L   		EQU		010h
FSR1H   		EQU		011h
FSR1L   		EQU		012h
TOSH    		EQU		016h
TOSL    		EQU		017h
STKPTR  		EQU		018h
	SFULL	EQU		7
	UNF		EQU		6
	SOV		EQU		5
	STKPTR2	EQU		2
	STKPTR1	EQU		1
	STKPTR0	EQU		0
PCLATH    	EQU		01ah
PCLATL    	EQU		01bh
TBLPTRH   	EQU		01dh
TBLPTRL   	EQU		01eh
TBLDH   		EQU		01fh	;
TBLDL   		EQU		020h	;
PRODH     	EQU		021h
PRODL     	EQU		022h
INTE1		EQU		023h
	GIE		EQU		7
	ADCIE	EQU		6
	TMCIE	EQU		5
	TMBIE	EQU		4
	TMAIE	EQU		3
	WDTIE	EQU		2
	E1IE		EQU		1
	E0IE		EQU		0
INTE2   		EQU		024h
     SSPIE   	EQU		2
	CCP1IE  	EQU		1
	CCP0IE  	EQU		0
INTF1   		EQU		026h
	ADCIF	EQU		6
	TMCIF	EQU		5
	TMBIF	EQU		4
	TMAIF	EQU		3
	WDTIF	EQU		2
	E1IF		EQU		1
	E0IF		EQU		0
INTF2   		EQU		027h
	SSPIF   	EQU		2
	CCP1IF  	EQU		1
	CCP0IF  	EQU		0
WREG     		EQU		029H
BSR     		EQU		02AH
STATUS     	EQU		02BH;{000, C, DC, N, OV, Z}
	C		EQU		4
	DC		EQU		3
	N		EQU		2
	OV		EQU		1
	Z		EQU		0
PSTATUS 		EQU		02CH
	PD		EQU		7
	TO		EQU		6
	IDLEB	EQU		5
	POR		EQU		4
	SVS		EQU		3
	SKEER	EQU		2
SVSCN		EQU		02DH	
	ENPOR	EQU		7	
	SVSFG	EQU		6	
	SVSOP	EQU		5
	SVSON	EQU		4	
	VLDX3	EQU		3			
	VLDX2	EQU		2			
	VLDX1	EQU		1			
	VLDX0	EQU		0			
SBMSET1		EQU		02EH	
	SKRST	EQU		7
	RCFTR5	EQU		5
	RCFTR4	EQU		4
	RCFTR3	EQU		3
	RCFTR2	EQU		2
	RCFTR1	EQU		1
	RCFTR0	EQU		0
PWRCN		EQU		030H
	ENVDDA	EQU		7
	VDDAX1	EQU		6
	VDDAX0	EQU		5
	ENREF	EQU		4
MCKCN1		EQU		031H	
	ADCS2	EQU		7
	ADCS1	EQU		6
	ADCS0	EQU		5
	ADCCK	EQU		4
	XTHSP	EQU		3
	XTSP		EQU		2
	ENXT		EQU		1
	ENRC2M	EQU		0
MCKCN2		EQU		032H
	LSCK		EQU		5
	HSCK		EQU		4
	HSS1		EQU		3
	HSS0		EQU		2
	CPUCK1	EQU		1	
	CPUCK0	EQU		0	
MCKCN3		EQU		033H
	LCDS2	EQU		7
	LCDS1	EQU		6
	LCDS0	EQU		5
	PERCK	EQU		3
	BZS2		EQU		2		
	BZS1		EQU		1		
	BZS0		EQU		0		
OP0CN1		EQU		037H
	ENOP		EQU		7	
	OPM1		EQU		6
	OPM0		EQU		5
	OPP1		EQU		4	
	OPP0		EQU		3		
	OPN2		EQU		2		
	OPN1		EQU		1			
	OPN0		EQU		0					
OP0CN2		EQU		038H
	DITHER2	EQU		5
	DITHER1	EQU		4	
	DITHER0	EQU		3		
	CHOPER2	EQU		2		
	CHOPER1	EQU		1			
	CHOPER0	EQU		0					
ADC0RH		EQU		039H	
ADC0RM		EQU		03AH	
ADC0RL		EQU		03BH	
ADC0CN1		EQU		03CH
	ENADC	EQU		7	
	ENHIGN	EQU		6	
	ENCHP	EQU		5	
	PGAGN1	EQU		4		
	PGAGN0	EQU		3
	ADGN2	EQU		2
	ADGN1	EQU		1
	ADGN0	EQU		0
ADC0CN2		EQU		03DH
	INBUF	EQU		5
	VRBUF	EQU		4
	VREGN	EQU		3
	DCSET2	EQU		2
	DCSET1	EQU		1
	DCSET0	EQU		0
ADC0CN3		EQU		03EH
	OSR2		EQU		7
	OSR1		EQU		6
	OSR0		EQU		5
AINET1		EQU		03FH
	INH2		EQU		7
	INH1		EQU		6
	INH0		EQU		5	
	INL2		EQU		4		
	INL1		EQU		3
	INL0		EQU		2
	INIS		EQU		1
	OPIS		EQU		0
AINET2		EQU		040H
	VRH1		EQU		6
	VRH0		EQU		5	
	INX1		EQU		4		
	INX0		EQU		3
	VRL1		EQU		2
	VRL0		EQU		1
TMACN		EQU		041H
	ENTMA	EQU		7
	TMAS2	EQU		6
	TMAS1	EQU		5	
	TMAS0	EQU		4	
	ENWDT	EQU		3
	WDTS2	EQU		2
	WDTS1	EQU		1
	WDTS0	EQU		0
TMAR			EQU		042H
TMBCN		EQU		043H
	ENTMB	EQU		7
	TMBCK	EQU		6
	TMBS1	EQU		5	
	TMBS0	EQU		4		
	TMBSYC	EQU		3
	TMBR2R	EQU		2
TMBRH		EQU		044H
TMBRL		EQU		045H
TMCCN		EQU		046H
	ENTMC	EQU		7
	TMCCK1	EQU		6
	TMCCK0	EQU		5	
	TMCS2	EQU		4
	TMCS1	EQU		3
	TMCS0	EQU		2
	TMCS01	EQU		1
	TMCS00	EQU		0
PRC			EQU		047H
TMCR			EQU		048H
CCPCN		EQU		049H
	CCP1M3	EQU		7
	CCP1M2	EQU		6
	CCP1M1	EQU		5	
	CCP1M0	EQU		4
	CCP0M3	EQU		3
	CCP0M2	EQU		2
	CCP0M1	EQU		1
	CCP0M0	EQU		0
CCP0RH		EQU		04AH
CCP0RL		EQU		04BH
CCP1RH		EQU		04CH
CCP1RL		EQU		04DH
PASC			EQU		04EH
	PASF		EQU		7
	PASCF2	EQU		6
	PASCF1	EQU		5	
	PASCF0	EQU		4
	PSS0CN1	EQU		3
	PSS0CN0	EQU		2
	PSS1CN1	EQU		1
	PSS1CN0	EQU		0
PWMCN		EQU		04FH
	ENPWM	EQU		7
	ENPFD	EQU		6
	PWMRL1	EQU		5	
	PWMRL0	EQU		4
	PWMCG1	EQU		3
	PWMCG0	EQU		2
	PWMM1	EQU		1
	PWMM0	EQU		0
PDBD			EQU		050H
	ENPRS	EQU		7
	DBDC6	EQU		6
	DBDC5	EQU		5	
	DBDC4	EQU		4
	DBDC3	EQU		3
	DBDC2	EQU		2
	DBDC1	EQU		1
	DBDC0	EQU		0
PWMR			EQU		051H
LCDCN1		EQU		052H
	ENLCD	EQU		7
	LCDPR	EQU		6
	VLCDX1	EQU		5	
	VLCDX0	EQU		4
	LCDBF	EQU		3
	LCDBI1	EQU		2
	LCDBI0	EQU		1
LCDCN2		EQU		053H
	LCDBL	EQU		7
	LCDMX1	EQU		6
	LCDMX0	EQU		5	
LCD0			EQU		054H
LCD1			EQU		055H
LCD2			EQU		056H
LCD3			EQU		057H
LCD4			EQU		058H
LCD5			EQU		059H
LCD6			EQU		05AH
LCD7			EQU		05BH
LCD8			EQU		05CH
LCD9			EQU		05DH
SSPCON1		EQU  	05EH
	SSPEN	EQU		7
	CKP		EQU		6
	CKE		EQU		5
	SMP		EQU		4
	SSPM1	EQU		1
	SSPM0	EQU		0
SSPSTA   		EQU	   	060H
	SSPBUY	EQU		7
	SSPOV	EQU		6
	BF		EQU		0
SSPBUF    	EQU	   	061H
PT1			EQU		06DH
TRISC1		EQU		06EH
PT1DA		EQU		06FH
PT1PU		EQU		070H
PT1M1		EQU		071H
	INTEG11	EQU		3
	INTEG10	EQU		2
	INTEG01	EQU		1
	INTEG00	EQU		0
PT1M2		EQU		072H
PT1INT		EQU		073H
	INTEG7	EQU		7
	INTEG6	EQU		6
	INTEG5	EQU		5	
	INTEG4	EQU		4
	INTEG3	EQU		3
	INTEG2	EQU		2
PT2			EQU		074H
TRISC2		EQU		075H
PT2DA		EQU		076H
PT2PU		EQU		077H
PT2M1		EQU		078H
PT2M2		EQU		079H
;===================================================                  	
	FSR0		EQU		0
	FSR1		EQU		1
	W       	EQU 		0
	F   		EQU 		1
	ACCE    	EQU 		0
	A    	EQU 		0
	BANK		EQU		1
	B		EQU		1
	S    	EQU 		1
	BIT0		EQU		0
	BIT1		EQU		1
	BIT2		EQU		2
	BIT3		EQU		3
	BIT4		EQU		4
	BIT5		EQU		5
	BIT6		EQU		6
	BIT7		EQU		7
	